-- Copyright (C) 1991-2013 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II 32-bit"
-- VERSION		"Version 13.0.1 Build 232 06/12/2013 Service Pack 1 SJ Web Edition"
-- CREATED		"Wed Nov 09 14:12:09 2016"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ULA IS 
	PORT
	(
		A :  IN  STD_LOGIC_VECTOR(31 DOWNTO 0);
		B :  IN  STD_LOGIC_VECTOR(31 DOWNTO 0);
		F :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		Cout :  OUT  STD_LOGIC;
		ZF :  OUT  STD_LOGIC;
		S :  OUT  STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END ULA;

ARCHITECTURE bdf_type OF ULA IS 

COMPONENT crtl_inv
	PORT(sel : IN STD_LOGIC;
		 data0x : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 data1x : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mux_out
	PORT(data0x : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 data1x : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 data2x : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 data3x : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT adder
	PORT(Cin : IN STD_LOGIC;
		 A : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 B : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 Cout : OUT STD_LOGIC;
		 Sinal : OUT STD_LOGIC;
		 S : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT minha_nor32
	PORT(N : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ZF : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	S_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	Zero_Ext :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_7 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_5 :  STD_LOGIC_VECTOR(31 DOWNTO 0);


BEGIN 



SYNTHESIZED_WIRE_4 <= A OR SYNTHESIZED_WIRE_7;


SYNTHESIZED_WIRE_3 <= SYNTHESIZED_WIRE_7 AND A;


b2v_inst2 : crtl_inv
PORT MAP(sel => F(2),
		 data0x => B,
		 data1x => SYNTHESIZED_WIRE_2,
		 result => SYNTHESIZED_WIRE_7);


SYNTHESIZED_WIRE_2 <= NOT(B);



b2v_inst4 : mux_out
PORT MAP(data0x => SYNTHESIZED_WIRE_3,
		 data1x => SYNTHESIZED_WIRE_4,
		 data2x => SYNTHESIZED_WIRE_5,
		 data3x => Zero_Ext,
		 sel => F(1 DOWNTO 0),
		 result => S_ALTERA_SYNTHESIZED);


b2v_inst5 : adder
PORT MAP(Cin => F(2),
		 A => A,
		 B => SYNTHESIZED_WIRE_7,
		 Cout => Cout,
		 Sinal => Zero_Ext(0),
		 S => SYNTHESIZED_WIRE_5);



b2v_inst7 : minha_nor32
PORT MAP(N => S_ALTERA_SYNTHESIZED,
		 ZF => ZF);

S <= S_ALTERA_SYNTHESIZED;

Zero_Ext(31 DOWNTO 1) <= "0000000000000000000000000000000";
END bdf_type;